from Products.CMFCore.utils import getToolByName
from Products.CMFFormController.FormAction import FormActionKey
from Products.Archetypes.Extensions.utils import installTypes
from Products.Archetypes.Extensions.utils import install_subskin
from Products.Archetypes.public import listTypes

from StringIO import StringIO

from Products.CMFDynamicViewFTI.migrate import migrateFTIs

from Products.PloneMiniPortal.config import *
from Products.PloneMiniPortal.MiniPortalTool import MiniPortalTool
#from Products.MiniPortal.Extensions.utils import *

def install(self):
    """Install MiniPortal: Install content types, skin layer, install the
    stylesheet, set up global properties, enable the portal factory and
    set up form controller actions for the widget actions
    """

    out = StringIO()

    print >> out, "Installing MiniPortal"

    # Install types
    classes = listTypes(PROJECTNAME)
    installTypes(self, out,
                 classes,
                 PROJECTNAME)
    print >> out, "Installed types"

    # Install tool
    add_tool = self.manage_addProduct[PROJECTNAME].manage_addTool
    pmp_tool = getattr(self, MiniPortalTool.id, None)
    if pmp_tool is None:
        add_tool(MiniPortalTool.meta_type)
    else:
        pmp_tool.initProperties()
    print >> out, "Installed tool"

    # Install skin
    install_subskin(self, out, product_globals)
    print >> out, "Installed skin"

    # Migrate FTI, to make sure we get the necessary infrastructure for the
    # 'display' menu to work.
    migrated = migrateFTIs(self, product=PROJECTNAME)
    print >>out, "Switched to DynamicViewFTI: %s" % ', '.join(migrated)

    # Install stylesheet
    portal_css = getToolByName(self, 'portal_css')
    portal_css.manage_addStylesheet(id = 'miniportal.css',
                                    expression = 'python:hasattr(object,"miniPortalParent")',
                                    title = 'MiniPortal styles',
                                    rendering = 'inline',
                                    cookable = False,
                                    enabled = True)
    print >>out, "Added stylesheet to css registry"

    # Enable portal_factory
    factory = getToolByName(self, 'portal_factory')
    types = factory.getFactoryTypes().keys()
    if 'MiniPortal' not in types:
        types.append('MiniPortal')
        factory.manage_setPortalFactoryTypes(listOfTypeIds = types)
        print >> out, "Added MiniPortal to portal_factory"
    else:
        print >> out, "MiniPortal already in portal_factory types"

    propsTool = getToolByName(self, 'portal_properties')
    siteProperties = getattr(propsTool, 'site_properties')
    navtreeProperties = getattr(propsTool, 'navtree_properties')

    # Add select ids to idsNotToList
    defaultIdsNotToList = list(navtreeProperties.getProperty('idsNotToList'))
    if 'MiniPortalBanner' not in defaultIdsNotToList:
        defaultIdsNotToList.append('MiniPortalBanner')
    navtreeProperties.manage_changeProperties(idsNotToList = defaultIdsNotToList)



    return out.getvalue()