

from AccessControl import ClassSecurityInfo
from OFS.PropertyManager import PropertyManager
from OFS.SimpleItem import SimpleItem 

from Products.CMFCore.utils import UniqueObject 
from Globals import InitializeClass 


class MiniPortalTool (PropertyManager, UniqueObject, SimpleItem): 
    """ MiniPortalTool  provides toolbox for MiniPortals """ 

    id = 'portal_miniportals' 
    meta_type= 'MiniPortal Tool' 
    title = 'PloneMiniPortals Tool'
    plone_tool = True
    security = ClassSecurityInfo()
    
#    credit_label = 'Credit DCN',
#    credit_description = 'If checked, will show a message at page bottom crediting DCN for site assistance.',

    def __init__(self):
        # Properties to be edited by site manager
        # Properties are initialized in manage_afterAdd
        pass

    security.declarePrivate('manage_afterAdd')
    def manage_afterAdd(self, item, container):
        """Update MiniPortal properties"""
        self.initProperties()

    security.declarePrivate('initProperties')
    def initProperties(self):
        """Initialize properties"""

#        self.safeEditProperty(self, 'credit_label', 'Credit DCN', data_type='string')
#        self.safeEditProperty(self,
#         'credit_description',
#         'If checked, will show a message at page bottom crediting DCN for site assistance.',
#         data_type='text')

        self.safeEditProperty(self, 'license_options', 
            ('|None',
             'mp_cc_a|Creative Commons Attribution',
             'mp_cc_a_sa|Creative Commons Attribution-ShareAlike',
             'mp_cc_a_nc|Creative Commons Attribution-NonCommercial',
             'mp_cc_a_nc_sa|Creative Commons Attribution-NonCommercial-ShareAlike'),
            data_type='lines')



    # Copied from CMFPlone/migrations/migration_util.py
    security.declarePrivate("safeEditProperty")
    def safeEditProperty(self, obj, key, value, data_type='string', new_value=None):
        """ An add or edit function, surprisingly useful :) """
        
        if obj.hasProperty(key):
            for property in self._properties:
                if property['id'] == key:
                    property['data_type'] = data_type
                    if data_type in ('selection', 'multiple selection'):
                        property['select_variable'] = value
                    break
        else:
            obj._setProperty(key, value, data_type)
            
            if new_value is not None:
                obj._updateProperty(key, new_value)

InitializeClass(MiniPortalTool) 