from Globals import package_home
from Products.CMFCore import utils, CMFCorePermissions, DirectoryView
from Products.CMFPlone.PloneUtilities import ToolInit
from Products.Archetypes.public import *
from Products.Archetypes import listTypes
from Products.Archetypes.utils import capitalize

import os, os.path, sys, content

import MiniPortalTool

# Module aliases - we don't always get it right on the first try, but and we
# can't move modules around because things are stored in the ZODB with the
# full module path. However, we can create aliases for backwards compatability.

sys.modules['Products.PloneMiniPortal.MiniPortal'] = content.miniportal
#sys.modules['Products.RichDocument.FileAttachemnt'] = content.attachments
#sys.modules['Products.RichDocument.ImageAttachemnt'] = content.attachments
#sys.modules['Products.RichDocument.widgets'] = widget
#sys.modules['Products.RichDocument.ImagesManagerWidget'] = widget.images
#sys.modules['Products.RichDocument.AttachmentsManagerWidget'] = widget.attachments


# Get configuration data, permissions
from Products.PloneMiniPortal.config import *

# Register skin directories so they can be added to portal_skins
DirectoryView.registerDirectory('skins', product_globals)
DirectoryView.registerDirectory('skins/MiniPortal', product_globals)
#DirectoryView.registerDirectory('skins/attachment_widgets', product_globals)

tools = ( MiniPortalTool.MiniPortalTool, ) 

def initialize(context):

    # Import the type, which results in registerType() being called
    from content import MiniPortal

    # initialize the content, including types and add permissions
    content_types, constructors, ftis = process_types(
        listTypes(PROJECTNAME),
        PROJECTNAME)

    utils.ContentInit(
        PROJECTNAME + ' Content',
        content_types      = content_types,
        permission         = DEFAULT_ADD_CONTENT_PERMISSION,
        extra_constructors = constructors,
        fti                = ftis,
        ).initialize(context)

    utils.ToolInit('MiniPortal Tool',
     tools=tools, icon='tool.gif', 
     product_name=PROJECTNAME,
     ).initialize(context) 