# miscellaneous validators for MiniPortal

from Products.validation.interfaces.IValidator import IValidator
from Products.validation import validation
import re


class cssColorValidator:
    __implements__ = IValidator
    
    def __init__(self, name):
        self.name = name
        self.cssCP3 = re.compile('#[0-9a-fA-F]{3,3}$')
        self.cssCP6 = re.compile('#[0-9a-fA-F]{6,6}$')
        self.cssKey = {
            'aqua': 1,
            'black':1,
            'blue':1,
            'fuchsia':1,
            'gray':1,
            'green':1,
            'lime':1,
            'maroon':1,
            'navy':1,
            'olive':1,
            'purple':1,
            'red':1,
            'silver':1,
            'teal':1,
            'white':1,
            'yellow':1,
        }
    
    def __call__(self, value, *args, **kwargs):
        mo = self.cssCP3.match(value)
        if mo:
            return 1
        mo = self.cssCP6.match(value)
        if mo:
            return 1
        if self.cssKey.has_key(value.lower()):
            return 1
        return """Validation failed: "%s" is not a CSS color.""" % value


validation.register(cssColorValidator('isCSSColor'))