## Script (Python) "createMPLevelTabs.py"
##title=Tabs for MiniPortal
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind subpath=traverse_subpath

# like plone_utils.createTopLevelTabs,
# but starts at mpPortalPath

actions = context.portal_actions.listFilteredActionsFor(context)

if not hasattr(context,"miniPortalParent"):
  return context.plone_utils.createTopLevelTabs(actions)

ct = context.portal_catalog
ntp = context.portal_properties.navtree_properties
stp = context.portal_properties.site_properties
view_action_types = stp.getProperty('typesUseViewActionInListings')
ut = context.plone_utils

# Build result dict
result = []

# first the actions
if actions is not None:
    for action_info in actions.get('portal_tabs', []):
        result.append(action_info.copy())

if not getattr(context, 'mpAutoTabs', True):
    # don't add folders as tabs
    return result

query = {}

portal_path = context.mpParentPath()
query['path'] = {'query':portal_path, 'depth':1}
#query['path'] = portal_path

query['portal_type'] = ut.typesToList()

if ntp.getProperty('sortAttribute', False):
    query['sort_on'] = ntp.sortAttribute

if (ntp.getProperty('sortAttribute', False) and
    ntp.getProperty('sortOrder', False)):
    query['sort_order'] = ntp.sortOrder

if ntp.getProperty('enable_wf_state_filtering', False):
    query['review_state'] = ntp.wf_states_to_show

query['is_default_page'] = False
query['is_folderish'] = True

# Get ids not to list and make a dict to make the search fast
ids_not_to_list = ntp.getProperty('idsNotToList', ())
excluded_ids = {}
for exc_id in ids_not_to_list:
    excluded_ids[exc_id]=1

rawresult = ct(**query)

# now add the content to results
for item in rawresult:
    if not (excluded_ids.has_key(item.getId) or item.exclude_from_nav):
        item_url = (item.portal_type in view_action_types and
                    item.getURL() + '/view') or item.getURL()
        data = {'name': ut.pretty_title_or_id(item),
                'id':item.getId, 'url': item_url, 'description':item.Description}
        result.append(data)

return result
