## Script (Python) "mpCreateBreadCrumbs.py"
##title=Breadcrumbs for MiniPortals
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind subpath=traverse_subpath

# Returns a structure for the portal breadcumbs.
# This is a copy of portal_utils.createBreadCrumbs
# modified to treat a MiniPortal as if it's a root.
# Also, if there's no MiniPortal, the 'Home' will
# be in the crumbs; this simplifies the logic of the global_pathbar

ct = context.portal_catalog
stp = context.portal_properties.site_properties
pu = context.plone_utils
view_action_types = stp.getProperty('typesUseViewActionInListings', ())
query = {}

# Check to see if the current page is a folder default view, if so
# get breadcrumbs from the parent folder
if pu.isDefaultPage(context):
    currentPath = '/'.join(context.aq_inner.aq_parent.getPhysicalPath())
else:
    currentPath = '/'.join(context.getPhysicalPath())
query['path'] = {'query':currentPath, 'navtree':1, 'depth': 0}

rawresult = ct(**query)

# Sort items on path length
dec_result = [(len(r.getPath()),r) for r in rawresult]
dec_result.sort(lambda x, y: cmp(x[0], y[0]))

# Build result dict
result = [{'Title':'Home', 'absolute_url':context.portal_url()}]
for r_tuple in dec_result:
    item = r_tuple[1]
    item_url = (item.portal_type in view_action_types and
                    item.getURL() + '/view') or item.getURL()
    if item.portal_type == 'MiniPortal':
        result = []
        data = {'Title': 'Home',
                'absolute_url': item_url}
    else:
        data = {'Title': pu.pretty_title_or_id(item),
                'absolute_url': item_url}
    result.append(data)
return result

